"""
 id: install_messages
 title: Install Messages *optional*
 module name: CMFMessage.Install
 function name: install
"""

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFMessage import Message, message_globals
from cStringIO import StringIO
import string

def install( self ):
    """register the CMF message content"""
    typestool = getToolByName( self, 'portal_types' )
    skinstool = getToolByName( self, 'portal_skins' )
    metadatatool = getToolByName( self, 'portal_metadata' )
    catalog = getToolByName( self, 'portal_catalog' )
    portal = getToolByName(self,'portal_url').getPortalObject()
    
    c_catalog = catalog._catalog

    slotpath = 'here/message_list_slot/macros/messagesBox'
    # setup typetool
    for t in Message.factory_type_information:
        if t['id'] not in typestool.objectIds():
            cfm = apply( ContentFactoryMetadata, (), t )
            typestool._setObject( t['id'], cfm )

    try:
        metadatatool.addElementPolicy( element='Subject'
                                       , content_type='Message'
                                       , is_required=0
                                       , supply_default=0
                                       , default_value=''
                                       , enforce_vocabulary=0
                                       , allowed_vocabulary=()
                                       , REQUEST=None
                                       )
    except:
        print 'Cannot add element policy'

    #add the tool
    portal.manage_addProduct['CMFMessage'].manage_addTool('CMF Message Tool', None)

    # setup skins
    if 'message' not in skinstool.objectIds():
        addDirectoryViews( skinstool, 'skins', message_globals )

    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath( skin )
        path = map( string.strip, string.split(path, ',') )
        if 'message' not in path:
            try: path.insert( path.index('content'), 'message' )
            except ValueError:
                path.append( 'message' )

            path = string.join( path, ', ' )

            skinstool.addSkinSelection( skin, path )
            
    try: #try to install the slot (bare except, because it will fail on bare CMF)
        if not slotpath in portal.right_slots:
            portal.right_slots = list(portal.right_slots) + [slotpath,]
    except: 
        pass

    return 'OK'

